'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ReactSlidyList;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSlidyItem = require('./react-slidy-item');

var _reactSlidyItem2 = _interopRequireDefault(_reactSlidyItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ReactSlidyList(_ref) {
  var className = _ref.className;
  var classNameItem = _ref.classNameItem;
  var currentSlide = _ref.currentSlide;
  var infinite = _ref.infinite;
  var items = _ref.items;
  var lazyLoadConfig = _ref.lazyLoadConfig;
  var enabledForItems = lazyLoadConfig.enabledForItems;
  var itemsOnLoad = lazyLoadConfig.itemsOnLoad;
  var componentPlaceholder = lazyLoadConfig.componentPlaceholder;


  var hasToLoadItem = function hasToLoadItem(index) {
    return !enabledForItems || infinite || enabledForItems && index < itemsOnLoad || enabledForItems && currentSlide + 1 >= index;
  };

  return _react2.default.createElement(
    'ul',
    { className: className },
    items.map(function (item, index) {
      var hasToLoad = hasToLoadItem(index);
      var itemToRender = hasToLoad ? item : componentPlaceholder;
      return _react2.default.createElement(
        _reactSlidyItem2.default,
        {
          className: classNameItem,
          key: index,
          load: hasToLoad },
        itemToRender
      );
    })
  );
}

ReactSlidyList.propTypes = {
  className: _react.PropTypes.string,
  classNameItem: _react.PropTypes.string,
  currentSlide: _react.PropTypes.number,
  infinite: _react.PropTypes.bool,
  items: _react.PropTypes.array,
  lazyLoadConfig: _react.PropTypes.object
};