'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSlidyList = require('./react-slidy-list');

var _reactSlidyList2 = _interopRequireDefault(_reactSlidyList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NO_OP = function NO_OP() {};

// in order to make react-slidy compatible with server-rendering
// by default slidy and imagesLoaded are empty functions
var slidy = NO_OP;
var imagesLoaded = NO_OP;

// if window is present, then we get the needed library
if (typeof window !== 'undefined' && window.document) {
  slidy = require('./slidy/slidy.js').slidy;
  imagesLoaded = require('imagesloaded');
}

var ReactSlidySlider = function (_Component) {
  _inherits(ReactSlidySlider, _Component);

  function ReactSlidySlider() {
    var _ref;

    _classCallCheck(this, ReactSlidySlider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = ReactSlidySlider.__proto__ || Object.getPrototypeOf(ReactSlidySlider)).call.apply(_ref, [this].concat(args)));

    _this.getFrameNode = _this.getFrameNode.bind(_this);
    _this.getSliderNode = _this.getSliderNode.bind(_this);
    _this.handleAfterSlide = _this.handleAfterSlide.bind(_this);
    _this.nextSlider = _this.nextSlider.bind(_this);
    _this.prevSlider = _this.prevSlider.bind(_this);
    _this.slidyInstance = null;

    _this.classes = {
      classNameItem: _this.getClassName('item'),
      classNameFrame: _this.getClassName('frame'),
      classNameSlideContainer: _this.getClassName('slides'),
      classNamePrevCtrl: _this.getClassName('prev'),
      classNameNextCtrl: _this.getClassName('next')
    };

    _this.state = { currentSlide: 0 };
    _this.sliderOptions = _extends({}, _this.classes, {
      doAfterSlide: _this.handleAfterSlide,
      // fix if the user try to use a `true` value for infinite
      infinite: _this.props.infinite === true ? 1 : _this.props.infinite,
      // if infinite, rewindOnResize is always true
      rewindOnResize: _this.props.rewindOnResize || _this.props.infinite
    });

    var children = _this.props.children;

    _this.DOM = {};
    _this.listItems = Array.isArray(children) ? children : [children];
    return _this;
  }

  _createClass(ReactSlidySlider, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // wait to load the images in order to start some stuff only when needed
      imagesLoaded(this.DOM['slider'], function () {
        var slidyOptions = _extends({}, _this2.props, _this2.sliderOptions, {
          frameDOMEl: _this2.DOM['frame']
        });
        // start slidy slider instance
        _this2.slidyInstance = slidy(_this2.DOM['slider'], slidyOptions);
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.slidyInstance && this.slidyInstance.destroy();
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, _ref2) {
      var currentSlide = _ref2.currentSlide;

      return currentSlide !== this.state.currentSlide;
    }
  }, {
    key: 'getClassName',
    value: function getClassName(element) {
      return this.props.classNameBase + '-' + element;
    }
  }, {
    key: 'getFrameNode',
    value: function getFrameNode(node) {
      this.DOM['frame'] = node;
    }
  }, {
    key: 'getSliderNode',
    value: function getSliderNode(node) {
      this.DOM['slider'] = node;
    }
  }, {
    key: 'handleAfterSlide',
    value: function handleAfterSlide(_ref3) {
      var currentSlide = _ref3.currentSlide;

      this.setState({ currentSlide: currentSlide }, function () {
        this.props.doAfterSlide({ currentSlide: currentSlide });
      });
    }
  }, {
    key: 'nextSlider',
    value: function nextSlider(e) {
      e.preventDefault();
      this.slidyInstance.next();
    }
  }, {
    key: 'prevSlider',
    value: function prevSlider(e) {
      e.preventDefault();
      this.slidyInstance.prev();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var infinite = _props.infinite;
      var lazyLoadConfig = _props.lazyLoadConfig;
      var showArrows = _props.showArrows;


      return _react2.default.createElement(
        'div',
        { ref: this.getSliderNode },
        _react2.default.createElement(
          'div',
          { ref: this.getFrameNode, className: this.sliderOptions.classNameFrame },
          showArrows && _react2.default.createElement('span', { className: this.sliderOptions.classNamePrevCtrl, onClick: this.prevSlider }),
          showArrows && _react2.default.createElement('span', { className: this.sliderOptions.classNameNextCtrl, onClick: this.nextSlider }),
          _react2.default.createElement(_reactSlidyList2.default, {
            className: this.sliderOptions.classNameSlideContainer,
            classNameItem: this.sliderOptions.classNameItem,
            currentSlide: this.state.currentSlide,
            lazyLoadConfig: lazyLoadConfig,
            infinite: infinite,
            items: this.listItems })
        )
      );
    }
  }]);

  return ReactSlidySlider;
}(_react.Component);

exports.default = ReactSlidySlider;


ReactSlidySlider.propTypes = {
  children: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]).isRequired,
  classNameBase: _react.PropTypes.string,
  doAfterSlide: _react.PropTypes.func,
  ease: _react.PropTypes.string,
  enableMouseEvents: _react.PropTypes.bool,
  infinite: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.number]),
  lazyLoadConfig: _react.PropTypes.object,
  onReady: _react.PropTypes.func,
  rewind: _react.PropTypes.bool,
  rewindOnResize: _react.PropTypes.bool,
  rewindSpeed: _react.PropTypes.number,
  showArrows: _react.PropTypes.bool,
  slideSpeed: _react.PropTypes.number,
  slidesToScroll: _react.PropTypes.number,
  snapBackSpeed: _react.PropTypes.number
};

ReactSlidySlider.defaultProps = {
  doAfterSlide: NO_OP,
  ease: 'ease',
  enableMouseEvents: true,
  infinite: 1,
  lazyLoadConfig: {
    enabledForItems: true,
    itemsOnLoad: 2,
    componentPlaceholder: _react2.default.createElement('div', null)
  },
  onReady: NO_OP,
  rewind: false,
  rewindOnResize: false,
  rewindSpeed: 300,
  showArrows: true,
  slideSpeed: 300,
  slidesToScroll: 1,
  snapBackSpeed: 300
};